#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PIL import Image

import sys
import os
import shutil

import pos

def load(file):
	lf = open(file)
	cont = lf.read()
	lf.close()
	
	return cont

class Builder:
	def __init__(self, input, output, skin, title):
		self.maindir = pos.DIR
		self.title = title
	
		if input[0:1] != '/':
			input = os.path.join(os.getcwd(), input)
	
		if output[0:1] != '/':
			output = os.path.join(os.getcwd(), output)
	
		exts = ('.jpg', '.jpeg', '.gif', '.tiff', '.png')
	
		if not os.path.exists(output):
			os.mkdir(output)
	
		# create the folders for work
		os.mkdir(os.path.join(output, 'thumbnails'))
		os.mkdir(os.path.join(output, 'pictures'))
	
		imgs = []
		for fle in os.listdir(input):
			file = os.path.join(input, fle)
		
			# if the item is a file
			if os.path.isfile(file):
				# if the file is an image
				if os.path.splitext(file)[1].lower() in exts:
					img = Image.open(file)
				
					imgs.append((fle, img.size[0], img.size[1], img.format, os.path.getsize(file)))
				
					# create the thumbnail
					img.thumbnail((160, 160), Image.ANTIALIAS)
				
					newpath = os.path.join(output, 'pictures', os.path.split(file)[1])
					shutil.copyfile(file, newpath)
				
					thumbpath = os.path.join(output, 'thumbnails', os.path.split(file)[1])
					img.save(thumbpath)
		
		self.start = ''
		self.end = ''
		self.text = ''
		self.addtxt = ''
	
		self.numofpags = int(round((len(imgs) / 20.0) + 0.4999))
	
		n = 0
		self.nf = 0
		line = 0
		for image in imgs:
			if n == 0:
				if self.nf == 0:
					t = ''
				else:
					t = '_'+str(self.nf)
			
				f = open(os.path.join(output, 'index'+t+'.html'), 'w')
			
				self.start = load(os.path.join(self.maindir, 'skins/', skin, 'start.txt'))
			
				self.addtxt = load(os.path.join(self.maindir, 'skins/', skin, 'addtxt.txt'))
			
				self.end = load(os.path.join(self.maindir, 'skins/', skin, 'end.txt'))
			
				self.nf += 1
		
			at = self.addtxt
			at = at.replace(':imagename:', os.path.splitext(image[0])[0])
			at = at.replace(':image:', image[0])
			at = at.replace(':imagex:', str(image[1]))
			at = at.replace(':imagey:', str(image[2]))
			at = at.replace(':imagetype:', str(image[3]))
			at = at.replace(':imagesize:', self.format(image[4]))
			
			if n == 20:
				self.page = self.start+self.text+self.end
			
				self.Sost()
			
				f.write(self.page)
				f.close()
				
				self.text = at
				
				n = -1
			else:
				if not n+1 % 5 and n != 0:
					self.text += at+'<br />'
			   	else:
					self.text += at
		
			n += 1
	
		if not f.closed:
			self.page = self.start+self.text+self.end
			
			self.Sost()
		
			f.write(self.page)
			f.close()
		
	def Sost(self):
		self.page = self.page.replace(':title:', self.title)
		self.page = self.page.replace(':pagnum:', str(self.nf))
		self.page = self.page.replace(':numofpags:', str(self.numofpags))
	
		if self.nf-1 == 0:
			self.page = self.page.replace(':previous:', '')
			self.page = self.page.replace(':pre:', '')
		else:
			self.page = self.page.replace(':previous:', '< Previous')
		
			if self.nf-1 == 1:
				self.page = self.page.replace(':pre:', 'index.html')
			else:
				self.page = self.page.replace(':pre:', 'index_'+str(self.nf-2)+'.html')
	
		if self.nf-1 == self.numofpags-1:
			self.page = self.page.replace(':next:', '')
			self.page = self.page.replace(':nex:', '')
		else:
			self.page = self.page.replace(':next:', 'Next >')
			self.page = self.page.replace(':nex:', 'index_'+str(self.nf)+'.html')
	
	def format(self, size):
		if size < 1024:
			return str(size) + ' byte'
		elif 1024 <= size < 1024*1024:
			return str(round(size / 1024.0, 1)) + ' Kb'
		else:
			return str(round((size / 1048576.0), 2)) + ' Mb'

if len(sys.argv) == 1:
	print '-h or --help for help'
# if the firts argument ask for help
elif sys.argv[1] in ('-h', '--help'):
	print
	print '### ALB web gallery creator ###'
	print 'Version: 0.1'
	print 'alb [-option1] [option_values1] [-option2] [option_values2] ...'
	print
	print 'Options:'
	print '    -h --help     show this help'
	print '    -i            input folder'
	print '    -o            output folder (the same as input if not specified)'
	print '    -s            skin used for build gallery (default if not specified)'
	print '    -t            self.title of your album'
	print 
	print 'if you want install a skin extract the skin archive in the /opt/alb/skins folder'
	print
else:
	input = ''
	output = ''
	skin = ''
	title = ''
	
	n = 0
	for arg in sys.argv:
		if arg == '-i':
			input = sys.argv[n+1]
		elif arg == '-o':
			output = sys.argv[n+1]
		elif arg == '-s':
			skin = sys.argv[n+1]
		elif arg == '-t':
			title = sys.argv[n+1]
		
		n += 1
	
	if output == '':
		output = input
	
	if skin == '':
		skin = 'default'
	
	Builder(input, output, skin, title)

